#Include "Protheus.ch" 
#Include "TopConn.ch" 
#INCLUDE "TBICONN.CH" 

User Function F200TIT()
Local aArea := GetArea()
         
msgAlert("Estou aqui")

FatTit()

RestArea(aArea)
Return

Static Function FatTit()
		
Local   lFat   := .F.
Private nNoCli := GetAdvFval("SA1","A1_NOME",xFilial("SA1")+SE1->E1_CLIENTE,1,"")
Private _aProd  := {} 
Private lRet   := .T.
Private cQuery := " "
Private cAlias1	:= GetNextAlias()

cQuery := "SELECT E1_NUM NUM, E1_PARCELA PAR, E1_IDCNAB CNAB FROM " + RetSqlName("SE1") + " SE1 WHERE SE1.D_E_L_E_T_= ' ' AND E1_FILIAL = '" + xFilial("SE1") + "' AND E1_IDCNAB = '" + cNumTit + "' AND E1_STATUS = 'B' "
MemoWrite(GetClientDir()+FunName()+ProcName()+__cUserId+".sql",cQuery)
dbUseArea(.T.,"TOPCONN",TCGenQry(,,cQuery),cAlias1,.F.,.T.)
ProcRegua((cAlias1)->(RecCount()))
	
While !(cAlias1)->(Eof()) 

	If ( Aviso("Baixar Titulo", "Deseja Faturar o Titulo "+cNumTit+" ?"+ CRLF +;
		"Cliente: " + nNoCli + CRLF +;
		"Valor do Titulo R$: " + AllTrim(Transform(SE1->E1_VALOR, "@E 999,999,999.99")) + CRLF;
		,{"Sim","No"})==1 )
		lFat := .T.
	EndIf
	
	If lFat 
		
		cQuery := "SELECT B1_COD, B1_DESC, B1_PRV1 FROM SB1010 SB1 WHERE SB1.D_E_L_E_T_= ' ' AND B1_FILIAL = '"+xFilial("SB1")+"' AND B1_GRUPO = '0008'"
		
		U_XGenSel_x('Servio Prestado','Escolha o Servio atribuido ao valor de ' + AllTrim(Transform(SE1->E1_VALOR, "@E 999,999,999.99")) + ' deste titulo.',"U_SelProd(aVetGen)", cQuery,,{'B1_COD','B1_DESC','B1_PRV1'})
	
	Endif
	    
	
	(cAlias1)->(dbSkip())

Enddo	

Return lRet

User Function SelProd(aVetGen)

Local flg    := 0

For i := 1 To Len(aVetGen)          
	If aVetGen[i][1] == .T.
		flg := flg + 1
		Aadd(_aProd, aVetGen[i][2])
	Endif
Next

If flg == 0
	msgAlert(" necessario apontar um Servio!!!")
	lRet := .F.
	Return lRet
Endif	

If flg > 1 
	msgAlert("Aponte apenas um servio por Titulo")
	lRet := .F.
	Return lRet
Endif	

If !Empty(_aProd)
	oDlgList:End()
	U_PedVen(_aProd)		
Endif

Return lRet

#Define AL_LEFT   0
#Define AL_CENTER 2
#Define AL_RIGHT  1


/* ========================================================================================= *
 * Rotina: XGenSel | Autor: Andr Luis de Oliveira | Data: 24/10/2011                                 *
 * ----------------------------------------------------------------------------------------- *
 * Descr.: Tela genrica de seleo de registros                                             *
 * ----------------------------------------------------------------------------------------- *
 * Params: _cTitulo - C  - Titulo da Janela                                                  *
 *       , _cMsg    - C  - Informao para usuario, descrio                                *
 *       , _cExecFx - C  - Funo com viso global a ser executada no boto OK               *
 *       , _cQryLst - C  - Query. Consulta para exibir os dados a serem selecionados.        *
 *       , _uTables - AC - (op)Tabela(s) a serem compatibilizadas, ou seja,                  *
 *                         campos Data, Numerico e etc sero mostrados conforme o Dicionario *
 *       , _aFields - A  - Campos contidos no retorno da query, que deseja exibir.           *
 *       , _aTitGds - A  - (op)Titulo das colunas dos grids                                  *
 *       , _aSizeGd - A  - (op)Tamanho dos campos do Grid                                    *
 *       , _aBtnExt - C  - (op)Vetor de botes adicionais a tela.                            *
 *       , _lDebug  - L  - (op)Variavel auxiliar de depurao.                               *
 * ========================================================================================= */
User Function XGenSel_x(_cTitulo, _cMsg ,_cExecFx, _cQryLst, _uTables, _aFields, _aTitGds, _aSizeGd, _aBtnExt, _lDebug)
Local   aTam      := {}
Private aVetGen   := {}
Private _cTitWin  := _cTitulo
Private cMsgInfo  := _cMsg
Private cExecFun  := _cExecFx
Private cQryList  := _cQryLst
Private aTables
Private aFieldsQ  := _aFields//{'COD','SERVICO'}
Private aTitulos  //:= {'COD','SERVICO'}
Private aSizeFds
Private aBtnExtd

Private lDebug

/* Variavel auxiliar de depurao */
Default _lDebug := .F.
lDebug := _lDebug
/* ------------------------------ */

/* Variavel que define o titulo dos campos referidos */
Default _aTitGds := {} //{'COD','SERVICO'}
If(Len(_aTitGds)<Len(aFieldsQ))
    For nIdx := Len(_aTitGds)+1 to Len(aFieldsQ)
        AAdd(_aTitGds, GetAdvFVal('SX3','X3_TITULO',aFieldsQ[nIdx], 2,aFieldsQ[nIdx]))
    Next nIdx
EndIf
aTitulos  := _aTitGds
/* ------------------------------------------------- */

Default _aSizeGd := {}
If(Len(_aSizeGd)<Len(aFieldsQ))
    For nIdx := Len(_aSizeGd)+1 to Len(aFieldsQ)
        aTam := TamSx3(aFieldsQ[nIdx])
        If(Empty(aTam))
            aTam := {10,0}
        EndIf
        AAdd( _aSizeGd, (aTam[1]+aTam[2]+1)*2 )
    Next nIdx
EndIf
aSizeFds  := _aSizeGd

/* -------------------------------------------------- */


/* Variavel de botes extras da janela */
Default _aBtnExt := {}
aBtnExtd := _aBtnExt
/* ----------------------------------- */

/* Variavel de compatibilizao de campos das tabelas */
Default _uTables := {}
If !(ValType(_uTables) $ 'UCA')
    Alert('Tipo invlido para o parametro _uTables['+ValType(_uTables)+']';
         +', tipos suportados pelo parametro so: Nil(U), Caracter(C) ou Vetor de Caracteres(A[C])')
    Return .F.
EndIf
If( ValType(_uTables)=='A' )
    For nIdx := 1 to Len(_uTables)
        If( ValType(_uTables[nIdx])!='C' )
            Alert('O Parametro _uTables['+Str(nIdx)+'] na referida posio no  do tipo Caracter.')
            Return .F.
        EndIf
    Next nIdx
EndIf

aTables := IIF(ValType(_uTables)=="A", _uTables, {_uTables} )
/* -------------------------------------------------- */

XGenTela()
Return aVetGen
/* XGenSel */


/* ===================================== *
 * Programa : Autor         : Data
 * XGenTela : Andr Luis de Oliveira : 24/10/2011
 * Monta tela de parametros
 * ===================================== */
Static Function XGenTela()
Local   lRet       := .T.
Local   oAll       := ""
Local   lAll       := .F.
Local   oListMnu   := ""
Local   oListTot   := ""
Local	oOk
Local 	oNo
Local 	aButtons   	:=	{}
Local   aTitHead    := {''}
Local   aSizeHead   := {1}
Local   nTamHMin    := 200
Local   nTamHMax    := 400
Local   nTamHAt     := aSizeHead[1]
Private oDlgList   	:= 	""
Private aAreaAtu   	:= 	GetArea()
Private oTotal     	:= 	""
Private oLeTxt     	:= 	""
Private nTotSE2    	:= 	0
Private cGetUG		:=	Space(2)
Private cGetLocal	:=	Space(10)
Private cDescUG		:=	""
Private cDescLocal	:=	""
Private dGetData	:=	dDatabase
Private cbLinMac    := '{|| {If( aVetGen[oListMnu:nAt,1], oOk, oNo )'

If ( Len(aTitulos)!=Len(aSizeFds) ;
.Or. Len(aFieldsQ)!=Len(aTitulos) )
    Alert('Tamanho dos Vetores de';
         +' Campos  ['+Len(aFieldsQ)+'],';
         +' Titulos ['+Len(aTitulos)+'] e';
         +' Tamanhos['+Len(aSizeFds)+'] no conferem.')
    Return .F.
EndIf

For nIdx := 1 to Len(aTitulos)
    AAdd(aTitHead , aTitulos[nIdx])
    AAdd(aSizeHead, aSizeFds[nIdx])
    cbLinMac += ', aVetGen[ oListMnu:nAt, '+Str(nIdx+1)+']'
    nTamHAt  += aSizeFds[nIdx]*1.5
Next nIdx

nTamHAt := IIf( nTamHAt < nTamHMin, nTamHMin,; // Usa valor Mnimo
           IIF( nTamHAt > nTamHMax, nTamHMax,; // Usa valor Mximo
                                    nTamHAt) ) // Usa valor Atual

//Alimenta lista clientes marcados.
XGenLIST(@aVetGen)
If( Len(aVetGen)==0 )
    If( MsgNoYes("No h itens para selecionar"+CRLF;
                +"Deseja prosseguir ?";
                ,"ATENO !") )
        &(cExecFun)
    EndIf
    Return .T.
EndIf

//Criao dos Botes:
//Boto Ok
oOk      := LoadBitmap( GetResources(), "LBOK" )
//Boto Cancelar/Fechar
oNo      := LoadBitmap( GetResources(), "LBNO" )


cbLinMac += '} }'
bLine    := &(cbLinMac)

//Define o Objeto Dialog( Form )
DEFINE MSDIALOG oDlgList TITLE _cTitWin FROM 000, 000 TO 460, nTamHAt*2+10 OF oMainWnd PIXEL
oSayTT := TSay():New( 015,005,{||cMsgInfo},oDlgList,,,.F.,.F.,.F.,.T.,,,nTamHAt,008)

//Monta o Grid de acordo com os parametros de campos
oListMnu := TCBrowse():New( 25 , 05, nTamHAt, 190,,;
                          aTitHead , aSizeHead,;//, {1,60,120,60},;
                          oDlgList,,,,,{||},,,,,,,.F.,,.T.,,.F.,,, )

oListMnu:SetArray( aVetGen )

//Atribui o Bloco de Processamento para a Marcao do Linha
oListMnu:bLine := bLine

//Define a Funcionalidade ao Executar o DblClick sobre o Registro
oListMnu:bLDblClick := {|nRowPix, nColPix, nKeyFlags| XGenSelect( @aVetGen, oListMnu ), oListMnu:Refresh(),If( lAll, ( lAll := .F., oDlgList:Refresh(),oAll:Refresh() ),)}

//@ 170, 06 CHECKBOX oAll VAR lAll PROMPT "Todos os Itens" FONT oDlgList:oFont PIXEL SIZE 80, 09 OF oDlgList ;
//          ON CLICK (Aeval( aVetGen,{ |x, y| aVetGen[y][1] :=  lAll } ), oListMnu:Refresh() )

//Mostra a Tela
ACTIVATE DIALOG oDlgList CENTERED ON INIT EnchoiceBar(oDlgList,{|| &(cExecFun), oDlgList:End() },{|| oDlgList:End()},,aBtnExtd)

RestArea(aAreaAtu)
Return lRet
/* XGenTela */


/* ==================================================================== *
 * Programa : Autor         : Data
 * XGenLIST : Andr Luis de Oliveira : 24/10/2011
 * Monta lista de Clientes
 * ==================================================================== */
Static Function XGenLIST(aVetRef)
Local cAlias   := GetNextAlias()
Local caTmpVet := '{.F.'

For nIdx := 1 to Len(aFieldsQ)
    caTmpVet += ', ' +aFieldsQ[nIdx]
              //+ ', X3Picture("'+aFieldsQ[nIdx]+'")))'
Next nIdx
caTmpVet += '}'

aVetRef := {}

DbUseArea(.T., 'TOPCONN', TCGenQry(,,cQryList), cAlias, .F., .T.)
DbSelectArea(cAlias)

For nIdx := 1 to Len(aTables)
    *---------------------------------------------------*
    *Compatibiliza os campos de acordo com a TopField
    *---------------------------------------------------*
    aEval( &(aTables[nIdx])->(dbStruct()),{|x| If(x[2]!="C", TcSetField(cAlias,AllTrim(x[1]),x[2],x[3],x[4]),Nil)})
Next nIdx

While (cAlias)->(!EOF())
    (cAlias)->( AAdd( aVetRef, &(caTmpVet) ) )
    (cAlias)->(DbSkip())
EndDo

DBCloseArea(cAlias)

Return
/* XGenLIST */


/* ======================================= *
 * Programa   : Autor         : Data       *
 * XGenSelect : Andr Luis de Oliveira : 24/10/2011 *
 * Manipula o checkbox de cada linha.      *
 * ======================================= */
Static Function XGenSelect(aVetGen, oListMnu)
Local nAt := oListMnu:nAt

aVetGen[ nAt, 1] := !aVetGen[ nAt, 1]
Return
/* XGenSelect */


/* ========================================================== *
 * Programa   : Autor         : Data                          *
 * X3Valid    : Andr Luis de Oliveira : 31/01/2011                    *
 * Pesquisa e monta validao como o sistema executa          *
 * Parametro  : cCampo - C - Campo, qual deseja a validao   *
 *              registrada no dicionario (SX3)                *
 * Retorno    : Validao do dicionario para o campo indicado *
 * ========================================================== */
User Function X3Valid(cCampo)
Local cRet   := ""
Local aValid := GetAdvFVal("SX3",{"X3_VALID", "X3_VLDUSER"},cCampo, 2, {})

For nX := 1 to Len(aValid)
    cRet += IIF(Len(AllTrim(cRet))>0," .And. ","")+aValid[nX]
Next nX

Return cRet
/* X3Valid */ 

User Function PedVen(_aProd) 
Local __aCabec        := {} 
Local __aItens        := {} 
Local __aLinha        := {} 
Local nX            := 0 
Local nY            := 0 
Local nItem         := 0
Local nQtdLib       := 0
Local _cSerie       := '1' 
Local _aPvlNfs      := {}
Local nI            := 0
Local _cTes         := '   '
PRIVATE lMsErroAuto := .F. 


cPed := GetSxeNum("SC5","C5_NUM") 
RollBAckSx8() 
__aCabec := {} 
__aItens := {} 

aadd(__aCabec,{"C5_NUM"   ,cPed,Nil}) 
aadd(__aCabec,{"C5_TIPO" ,"N",Nil}) 
aadd(__aCabec,{"C5_CLIENTE",SE1->E1_CLIENTE,Nil})     
aadd(__aCabec,{"C5_LOJACLI",SE1->E1_LOJA,Nil}) 
aadd(__aCabec,{"C5_TIPOCLI","F",Nil})     
aadd(__aCabec,{"C5_CONDPAG",'001',Nil}) 


For i := 1 To Len(_aProd)
	_cTes := GetAdvFval("SB1","B1_TS",xFilial("SB1")+_aProd[i],1," ")
	__aLinha := {}    
	aadd(__aLinha,{"C6_ITEM",strzero(nItem+1,2),Nil})    
	aadd(__aLinha,{"C6_PRODUTO",_aProd[i],Nil})    
	aadd(__aLinha,{"C6_QTDVEN",1,Nil})    
	aadd(__aLinha,{"C6_PRCVEN",SE1->E1_VALOR,Nil})    
	aadd(__aLinha,{"C6_PRUNIT",SE1->E1_VALOR,Nil})    
	aadd(__aLinha,{"C6_VALOR",SE1->E1_VALOR,Nil})    
	aadd(__aLinha,{"C6_TES",Iif(!Empty(_cTes),_cTes,"502"),Nil})    
	aadd(__aItens,__aLinha) 
Next

//Ŀ 
//| Teste de Inclusao                                           | 
// 

MsExecAuto({|x, y, z| MATA410(x, y, z)}, __aCabec, __aItens, 3) 

If lMsErroAuto 
	Alert("Erro na inclusao!") 
	lRet := .F.
	MostraErro()
	Return lRet 
EndIf 

DBSelectArea("SC5")
DBSetOrder(1)
MsSeek( xFilial("SC5") + cPed)


dbSelectArea("SC6")
DBSetOrder(1)
MsSeek( xFilial("SC6") + cPed )

nValTot := 0
While !EOF() .And. C6_NUM == cPed
     nValTot += SC6->C6_VALOR
     
     If RecLock("SC5")
          nQtdLib := SC6->C6_QTDLIB
          //Ŀ
          //Recalcula a Quantidade Liberada                                         
          //
          RecLock("SC6") //Forca a atualizacao do Buffer no Top
          //Ŀ
          //Libera por Item de Pedido                                               
          //
          Begin Transaction
	          MaLibDoFat(SC6->(RecNo()),1,.T.,.T.,.F.,.F.,.F.,.F.)
          End Transaction
     EndIf
     SC6->(MsUnLock())
     //Ŀ
     //Atualiza o Flag do Pedido de Venda                                      
     //
     Begin Transaction
     	SC6->(MaLiberOk({cPed},.T.))
     End Transaction
     
     dbSelectArea("SC6")
     dbSkip()
End

SC6->(dbCloseArea())

     For nI := 1 to len(__aItens)
     
          SC9->(DbSetOrder(1))
          SC9->(DbSeek(xFilial("SC9")+cPed ))    
          SC5->(DbSetOrder(1))
          SC5->(DbSeek(xFilial("SC5")+cPed ))    
          SC6->(DbSetOrder(1))
          SC6->(DbSeek(xFilial("SC6")+cPed+__aItens[nI][1][2] ))   
          SE4->(DbSetOrder(1))
          SE4->(DbSeek(xFilial("SE4")+'001' ))                   
          SB1->(DbSetOrder(1))
          SB1->(DbSeek(xFilial("SB1")+__aItens[nI][2][2]))         
          SB2->(DbSetOrder(1))
          SB2->(DbSeek(xFilial("SB2")+__aItens[nI][2][2]))     
          SF4->(DbSetOrder(1))
          SF4->(DbSeek(xFilial("SF4")+__aItens[nI][7][2]))     
          
          aAdd( _aPvlNfs , {     cPed,;                    
                                   __aItens[nI][1][2]     ,;  
                                   __aItens[nI][1][2]     ,;  
                                   __aItens[nI][3][2]     ,;  
                                   __aItens[nI][4][2]     ,;  
                                   __aItens[nI][2][2]     ,;  
                                   .F.                     ,;
                                   SC9->(RecNo())          ,;
                                   SC5->(RecNo())          ,;
                                   SC6->(RecNo())          ,;
                                   SE4->(RecNo())          ,;
                                   SB1->(RecNo())          ,;
                                   SB2->(RecNo())          ,;
                                   SF4->(RecNo())          })
          
     Next nI
     
     
     cNota := MaPvlNfs(_aPvlNfs, _cSerie, .F., .F., .F., .T., .F., 0, 0, .F., .F.)
     _aPvlNfs := {}
      
Aviso("Baixa Faturada com Sucesso!!!", "Cliente: "+Alltrim(nNoCli)+" - Pedido Gerado: " + cPed + CRLF +;
"Nota Fiscal: " + AllTrim(cNota) + " - Srie: "+Alltrim(_cSerie)+" - Valor Total R$: " + AllTrim(Transform(SE1->E1_VALOR, "@E 999,999,999.99")) + CRLF +;
"Para Validar a Nota Fiscal de Servio junto ao orgo publico, por favor" + CRLF +;
"trasmitir estes dados para a SEFAZ, acessando ambiente de Faturamento.",{"OK"} )
    
   //	RecLock( "SE1" , .F. )
 //	SE1->E1_XNF := cNota
//MsUnLock()	

Return lRet



